net.sf.saxon.expr.sort

## Class RuleBasedSubstringMatcher

- java.lang.Object
- - net.sf.saxon.expr.sort.SimpleCollation
  - - net.sf.saxon.expr.sort.RuleBasedSubstringMatcher

- All Implemented Interfaces:
    Serializable, StringCollator, SubstringMatcher

      public class RuleBasedSubstringMatcher
      extends SimpleCollation
      implements SubstringMatcher

  This class wraps a RuleBasedCollator to provide a SubstringMatcher. This users the facilities offered by the RuleBasedCollator to implement the XPath functions contains(), starts-with(), ends-with(), substring-before(), and substring-after().
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RuleBasedSubstringMatcher(RuleBasedCollator collator)` Create a RuleBasedSubstringMatcher

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `contains(String s1, String s2)` Test whether one string contains another, according to the rules of the XPath contains() function
    `boolean` | `endsWith(String s1, String s2)` Test whether one string ends with another, according to the rules of the XPath ends-with() function
    `Object` | `getCollationKey(String s)` Get a collation key for two Strings.
    `static void` | `main(String[] args)` Test program to output the sequence of collation element iterators for a given input string
    `boolean` | `startsWith(String s1, String s2)` Test whether one string starts with another, according to the rules of the XPath starts-with() function
    `String` | `substringAfter(String s1, String s2)` Return the part of a string after a given substring, according to the rules of the XPath substring-after() function
    `String` | `substringBefore(String s1, String s2)` Return the part of a string before a given substring, according to the rules of the XPath substring-before() function

    - ### Methods inherited from class net.sf.saxon.expr.sort.SimpleCollation

      `comparesEqual, compareStrings, getCollation, setCollation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.lib.StringCollator

      `comparesEqual, compareStrings`

- - ### Constructor Detail

    - #### RuleBasedSubstringMatcher

          public RuleBasedSubstringMatcher(RuleBasedCollator collator)

      Create a RuleBasedSubstringMatcher
      Parameters:
        `collator` - the collation to be used

  - ### Method Detail

    - #### contains

          public boolean contains(String s1,
                         String s2)

      Test whether one string contains another, according to the rules of the XPath contains() function
      Specified by:
        `contains` in interface `SubstringMatcher`
      Parameters:
        `s1` - the containing string
        `s2` - the contained string
      Returns:
        true iff s1 contains s2

    - #### endsWith

          public boolean endsWith(String s1,
                         String s2)

      Test whether one string ends with another, according to the rules of the XPath ends-with() function
      Specified by:
        `endsWith` in interface `SubstringMatcher`
      Parameters:
        `s1` - the containing string
        `s2` - the contained string
      Returns:
        true iff s1 ends with s2

    - #### startsWith

          public boolean startsWith(String s1,
                           String s2)

      Test whether one string starts with another, according to the rules of the XPath starts-with() function
      Specified by:
        `startsWith` in interface `SubstringMatcher`
      Parameters:
        `s1` - the containing string
        `s2` - the contained string
      Returns:
        true iff s1 starts with s2

    - #### substringAfter

          public String substringAfter(String s1,
                              String s2)

      Return the part of a string after a given substring, according to the rules of the XPath substring-after() function
      Specified by:
        `substringAfter` in interface `SubstringMatcher`
      Parameters:
        `s1` - the containing string
        `s2` - the contained string
      Returns:
        the part of s1 that follows the first occurrence of s2

    - #### substringBefore

          public String substringBefore(String s1,
                               String s2)

      Return the part of a string before a given substring, according to the rules of the XPath substring-before() function
      Specified by:
        `substringBefore` in interface `SubstringMatcher`
      Parameters:
        `s1` - the containing string
        `s2` - the contained string
      Returns:
        the part of s1 that precedes the first occurrence of s2

    - #### getCollationKey

          public Object getCollationKey(String s)

      Get a collation key for two Strings. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are compare correctly under the equals() method.
      Specified by:
        `getCollationKey` in interface `StringCollator`
      Overrides:
        `getCollationKey` in class `SimpleCollation`
      Parameters:
        `s` - the string whose collation key is required
      Returns:
        the collation key

    - #### main

          public static void main(String[] args)
                           throws Exception

      Test program to output the sequence of collation element iterators for a given input string
      Parameters:
        `args` - command line arguments (collationURI, test-string)
      Throws:
        `Exception`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.